//{$WARNINGS OFF}
//=============================================================================
//  EBhE̊Kw̃c[\
//
//  TreeVeiwőIEBhE͂ޘg`悷@\t
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N0526 `
//  2014N0728 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY and Halbow
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit WindowTreeUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, plWindowRectFormUnit;

type
  TWindowTreeForm = class(TForm)
    TreeView1: TTreeView;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    RectForm : TplWindowRectForm;
    procedure EnumChildren(Node:TTreeNode);
  public
    { Public 錾 }
    hTargetWnd      : HWND;
    TargetClassName : String;
  end;

var
  WindowTreeForm: TWindowTreeForm;

implementation

{$R *.DFM}

uses WinSearch;

//=============================================================================
//  tH[쐬
//  ݂̉EBhẼXg쐬
//  YtWinSearch.pas̊֐ނ𗘗p
//
//  ̃tH[̊e{^̃vpeB͈ȉ̒ʂ
//  [OK]     ModalResult := mrOK;
//           Default := True;
//  [Cancel] ModalResult := mrCancel;
//           Cancel := True;
//=============================================================================
procedure TWindowTreeForm.FormCreate(Sender: TObject);
var
  WA       : THWndArray;
  i        : Integer;
  Num      : Integer;
  StrItem  : String;
  StrClass : String;
  StrText  : String;
  Node     : TTreeNode;
begin
  Num := WinSearch.EnumVisbleNoOwnedWindows(WA);

  if Num > 0 then begin
    for i := 1 to Num do begin
      //Av͏O
      if (WA[i] <> Application.Handle) and
         (WA[i] <> Application.MainForm.Handle) then begin
        StrClass := WinSearch.GetClassNameStr(WA[i]);
        StrText  := WinSearch.GetWindowTextStr(WA[i]);
        StrItem  := Format('%s ...... %s', [StrClass, StrText]);

        //m[hȉ̃EBhE
        Node := TreeView1.Items.AddObject(nil, StrItem, Pointer(WA[i]));
        EnumChildren(Node);
      end;
    end;
  end;

  TreeView1.TopItem.Expand(False);
end;

//=============================================================================
//  tH[鎞
//  CtH[(ĂяõtH[)ɈnϐɒlZbg
//
//  hTargetWnd      : Ώۂ̃EBhẼnh
//  TargetClassName : Ώۂ̃EBhẼNX
//=============================================================================
procedure TWindowTreeForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Assigned(RectForm) then begin
    RectForm.Close;
    FreeAndNil(RectForm);
  end;

  if ModalResult = mrOk then begin
    if TreeView1.Selected <> nil then begin
      hTargetWnd      := HWND(TreeView1.Selected.Data);
      TargetClassName := WinSearch.GetClassNameStr(hTargetWnd);
    end;
  end else begin
    hTargetWnd := 0;
  end;
end;

//=============================================================================
//  ̃m[hɑEBhȆSĂ̎qEBhEWJ
//
//  ł́C̃EBhE̓c[ɒǉȂ悤ɂĂ
//=============================================================================
procedure TWindowTreeForm.EnumChildren(Node: TTreeNode);
var
  WA      : THWndArray;
  i       : Integer;
  Num     : Integer;
  TN      : TTreeNode;
  StrItem : String;
begin
  if Node.Count > 0 then exit;

  Num := WinSearch.EnumDirectChildren(WA, HWND(Node.Data));
  if Num > 0 then begin
    for i := 1 to Num do begin
      if IsWindowVisible(WA[i]) then begin
        StrItem := WinSearch.GetClassNameStr(WA[i]);
        TN      := TreeView1.Items.AddChildObject(Node, StrItem, Pointer(WA[i]));
        EnumChildren(TN);
      end;
    end;
  end;

  Num := WinSearch.EnumDirectOwnedWindows(WA, HWND(Node.Data));
  if Num > 0 then begin
    for i := 1 to Num do begin
      if IsWindowVisible(WA[i]) then begin
        StrItem := '*' + WinSearch.GetClassNameStr(WA[i]);
        TN      := TreeView1.Items.AddChildObject(Node, StrItem, Pointer(WA[i]));
        EnumChildren(TN);
      end;
    end;
  end;
end;

//=============================================================================
//  c[r[̃m[hNbNqEBhE
//  xWJƁCc[ĂȌ̂܂
//  Vɂɂ́Cēx̃tH[J
//=============================================================================
procedure TWindowTreeForm.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
  RectWnd    : TRect;
  LineWidth  : Integer;
  LineColor  : TColor;
begin
  if (Node.Level = 0) and (Node.Count = 0) then begin
    EnumChildren(Node);
    Node.Expand(True);
  end;

  if not (Assigned(RectForm)) then begin
    RectForm := TplWindowRectForm.Create(Self);
    RectForm.Show;
  end else begin
    RectForm.Canvas.FillRect(RectForm.ClientRect);
  end;

  //Ώۂ̃EBhE\̎͘g\Ȃ
  if IsWindowVisible(HWND(Node.Data)) then begin

    //TCYƈʒu擾
    GetWindowRect(HWND(Node.Data), RectWnd);

    LineWidth := 4;
    LineColor := clRed;

    //g`
    with RectForm.Canvas do begin
      Pen.Color := LineColor;
      Pen.Width := LineWidth;

      MoveTo (RectWnd.Left,  RectWnd.Top);
      LineTo (RectWnd.Right, RectWnd.Top);
      LineTo (RectWnd.Right, RectWnd.Bottom);
      LineTo (RectWnd.Left,  RectWnd.Bottom);
      LineTo (RectWnd.Left,  RectWnd.Top);
    end;
    Sleep(1);
  end;
end;

end.
