//{$WARNINGS OFF}
//=============================================================================
//  EBhE̊e擾p֐̃jbg
//
//  HalbowقŒ񋟒̓̃jbgCDelphi 2009ȍ~łgp\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2004N0119 Halbowق̃TvƂāCTCgŔzzJn
//  2012N0308 Delphi 2009ȍ~łgp\ȃR[hɏC
//  2014N0728 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY and Halbow
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit WinSearch;

interface

uses
  Windows, Messages, SysUtils, Classes, ComCtrls, Forms;

type
  //EBhEnhl̊i[pz
  //ŏ̗vf(0)̓JE^ƂĎgp
  THWndArray = array[0..500] of HWND;
  PHWndArray = ^THWndArray;

function IsChildWindow(Handle: HWND): Boolean;
function GetClassNameStr(hWindow: HWND): String;
function GetWindowTextStr(hWindow: HWND): String;
procedure ClassInfos(LV: TListView; hWindow: HWND);
procedure WindowInfos(LV: TListView; hWindow: HWND);
function IsOwnedWindow(hWindow: HWND): Boolean;
function AEnumWindows(var WA: THWndArray): Integer;
function EnumVisbleNoOwnedWindows(var WA: THWndArray): Integer;
function EnumVisibleNoOwnedWindowAsZOrder(var WA: THWndArray): Integer;
function EnumWindowsOfClassNameAsZOrder(var WA: THWndArray;
  ClassName: String): Integer;
function AEnumThreadWindows(var WA: THWndArray; OneOfHandles: HWND): Integer;
function AEnumChildWindows(var WA: THWndArray; hParent: HWND): Integer;
function FindChildOfClass(hParent: HWND; ClassName: String): HWND;
function EnumDirectChildren(var WA: THWndArray; hParent: HWND): Integer;
function GetMostTopLevelWindow(hWindow: HWND): HWND;
function EnumDirectOwnedWindows(var WA: THWndArray; hOwner: HWND): Integer;

implementation

//=============================================================================
//  ̃EBhEqEBhE𒲍
//  qEBhÉC̃EBhEX^CWS_CHILD܂ł邱Ƃ𗘗p
//=============================================================================
function IsChildWindow(Handle: HWND): Boolean;
begin
  Result := (GetWindowLong(Handle, GWL_STYLE) and WS_CHILD) <> 0;
end;

//=============================================================================
//  EBhẼNX擾֐
//=============================================================================
function GetClassNameStr(hWindow: HWND): String;
var
  Buffer : array[0..MAX_PATH-1] of Char;
  Len    : Integer;
begin
  System.FillChar(Buffer, SizeOf(Buffer), #0);
  Len := Windows.GetClassName(hWindow, Buffer, Length(Buffer));
  if Len > 0 then Result := Buffer else Result := '';
end;

//=============================================================================
//  EBhẼ^Cg擾֐
//=============================================================================
function GetWindowTextStr(hWindow: HWND): String;
var
  Buffer : array[0..MAX_PATH-1] of Char;
  Len    : Integer;
begin
  System.FillChar(Buffer, SizeOf(Buffer), #0);
  Len := Windows.GetWindowText(hWindow, Buffer, Length(Buffer));
  if Len > 0 then Result := Buffer else Result := '';
end;

//=============================================================================
//  EBhẼNXXgr[ɒǉ
//=============================================================================
procedure ClassInfos(LV: TListView; hWindow: HWND);

  //---------------------------------------------------------------------------
  procedure ListViewItemAdd(LV: TListView; ACaption, SubItem: String);
  var
    LVItem : TListItem;
  begin
    LVItem               := LV.Items.Add;
    LVItem.Caption       := ACaption;
    LVItem.SubItems.Text := SubItem;
  end;
  //---------------------------------------------------------------------------

var
  WC     : TWndClass;
  S      : String;
  Value  : Integer;
  FmtStr : String;
begin
  S := GetClassNameStr(hWindow);
  ListViewItemAdd (LV, 'ClassName', S);
  Windows.GetClassInfo(hInstance, PChar(S), WC);

  Value  := Windows.GetClassLong(hWindow, GCL_STYLE);
  FmtStr := Format('$%.8x', [Value, 8]);
  ListViewItemAdd (LV, 'Style', FmtStr);

  Value  := Windows.GetClassLong(hWindow, GCL_WNDPROC);
  FmtStr := Format('$%.8x', [Value]);
  ListViewItemAdd (LV, 'WndProc', FmtStr);

  Value  := Windows.GetClassLong(hWindow, GCL_HMODULE);
  FmtStr := Format('$%.8x', [Value]);
  ListViewItemAdd (LV, 'hModule', FmtStr);

  Value  := Windows.GetClassLong(hWindow, GCL_CBCLSEXTRA);
  FmtStr := Format('$%.8x bytes', [Value]);
  ListViewItemAdd (LV, 'ClsExtra', FmtStr);

  Value  := Windows.GetClassLong(hWindow, GCL_CBWNDEXTRA);
  FmtStr := Format('$%.8x bytes', [Value]);
  ListViewItemAdd (LV, 'WndExtra', FmtStr);

  Value  := Windows.GetClassLong(hWindow, GCL_HICON);
  FmtStr := Format('$%.8x', [Value]);
  ListViewItemAdd (LV, 'hIcon', FmtStr);

  Value  := Windows.GetClassLong(hWindow, GCL_HBRBACKGROUND);
  FmtStr := Format('$%.8x', [Value]);
  ListViewItemAdd (LV, 'hBrush', FmtStr);

  Value  := Windows.GetClassLong(hWindow, GCL_HCURSOR);
  FmtStr := Format('$%.8x', [Value]);
  ListViewItemAdd (LV, 'hCursor', FmtStr);
end;

//=============================================================================
//  EBhE̊eXgr[ɒǉ
//=============================================================================
procedure WindowInfos(LV: TListView; hWindow: HWND);

  //---------------------------------------------------------------------------
  procedure ListViewItemAdd(LV: TListView; ACaption, SubItem: String);
  var
    LVItem : TListItem;
  begin
    LVItem               := LV.Items.Add;
    LVItem.Caption       := ACaption;
    LVItem.SubItems.Text := SubItem;
  end;
  //---------------------------------------------------------------------------

var
  Value  : Integer;
  FmtStr : String;
begin
  ListViewItemAdd (LV, 'TEXT', GetWindowTextStr(hWindow));

  FmtStr := Format('$%.8x (%d)', [hWindow, hWindow]);
  ListViewItemAdd (LV, 'HANDLE', FmtStr);

  Value  := Windows.GetWindowLong(hWindow, GWL_EXSTYLE);
  FmtStr := Format('$%.8x', [Value]);
  ListViewItemAdd (LV, 'EXSTYLE', FmtStr);

  Value  := Windows.GetWindowLong(hWindow, GWL_STYLE);
  FmtStr := Format('$%.8x', [Value]);
  ListViewItemAdd (LV, 'STYLE', FmtStr);

  Value  := Windows.GetWindowLong(hWindow, GWL_WNDPROC);
  FmtStr := Format('$%.8x', [Value]);
  ListViewItemAdd (LV, 'WNDPROC', FmtStr);

  Value  := Windows.GetWindowLong(hWindow, GWL_HINSTANCE);
  FmtStr := Format('$%.8x', [Value]);
  ListViewItemAdd (LV, 'HINSTANCE', FmtStr);

  Value  := Windows.GetWindowLong(hWindow, GWL_HWNDPARENT);
  FmtStr := Format('$%.8x (%d)', [Value, Value]);
  ListViewItemAdd (LV, 'HWNDPARENT', FmtStr);

  Value  := Windows.GetWindowLong(hWindow, GWL_ID);
  FmtStr := Format('$%.8x (%d)', [Value, Value]);
  ListViewItemAdd(LV, 'ID', FmtStr);
end;

//=============================================================================
//  ̃EBhEI[i[EBhEł邩𒲍
//=============================================================================
function IsOwnedWindow(hWindow: HWND): Boolean;
begin
  Result := Windows.GetWindow(hWindow, GW_OWNER) <> 0;
end;

//-----------------------------------------------------------------------------
//  EnumWindows̃R[obN֐
//-----------------------------------------------------------------------------
function EnumWndProc(hWindow: HWND; lData: LPARAM): BOOL; stdcall;
var
  pWA : PHWndArray;
begin
  pWA           := PHWndArray(lData);
  pWA^[0]       := pWA^[0] + 1;
  pWA^[pWA^[0]] := hWindow;

  Result := True;
end;

//=============================================================================
//  EnumWindows̃bp[
//  SẴgbvxEBhE̗
//=============================================================================
function AEnumWindows(var WA: THWndArray): Integer;
begin
  WA[0] := 0;
  EnumWindows(@EnumWndProc, LPARAM(@WA));
  Result := WA[0];
end;

//-----------------------------------------------------------------------------
//  EnumWindows̃R[obN֐
//-----------------------------------------------------------------------------
function EnumVisbleNoOwnedWndProc(hWindow: HWND; lData: LPARAM): BOOL; stdcall;
var
  pWA : PHWndArray;
begin
  Result := True;
  if IsOwnedWindow(hWindow) then exit;
  if not Windows.IsWindowVisible(hWindow) then exit;

  pWA           := PHWndArray(lData);
  pWA^[0]       := pWA^[0] + 1;
  pWA^[pWA^[0]] := hWindow;
end;

//=============================================================================
//  ŏLĂȂgbvxEBhE̗
//=============================================================================
function EnumVisbleNoOwnedWindows(var WA: THWndArray): Integer;
begin
  WA[0] := 0;
  EnumWindows(@EnumVisbleNoOwnedWndProc, LPARAM(@WA));
  Result := WA[0];
end;

//=============================================================================
//  GetWindow
//  Z-Order̍񋓂
//=============================================================================
function EnumVisibleNoOwnedWindowAsZOrder(var WA: THWndArray): Integer;
var
  hWindow : HWND;
begin
  WA[0]   := 0;
  hWindow := GetWindow(Application.Handle, GW_HWNDFIRST);

  while (hWindow <> 0) do begin
    if (not IsOwnedWindow(hWindow)) and
       Windows.IsWindowVisible(hWindow) then begin
      WA[0]     := WA[0] + 1;
      WA[WA[0]] := hWindow;
    end;
    hWindow := Windows.GetWindow(hWindow, GW_HWNDNEXT);
  end;
  Result := WA[0];
end;

//=============================================================================
//  ClassNamẽEBhEZ-Order̍񋓂
//=============================================================================
function EnumWindowsOfClassNameAsZOrder(var WA: THWndArray;
  ClassName: String): Integer;
var
  hWindow : HWND;
begin
  WA[0]   := 0;
  hWindow := Windows.GetWindow(Application.Handle, GW_HWNDFIRST);

  while (hWindow <> 0) do begin
    if (not IsOwnedWindow(hWindow))     and
       Windows.IsWindowVisible(hWindow) and
       (UpperCase(GetClassNameStr(hWindow)) = UpperCase(ClassName)) then begin
      WA[0]     := WA[0] + 1;
      WA[WA[0]] := hWindow;
    end;
    hWindow := Windows.GetWindow(hWindow, GW_HWNDNEXT);
  end;
  Result := WA[0];
end;

//-----------------------------------------------------------------------------
//  EnumThreadWindows̃R[obN֐
//-----------------------------------------------------------------------------
function EnumThreadWndProc(hWindow: HWND; lData: LPARAM): BOOL; stdcall;
var
  pWA : PHWndArray;
begin
  pWA           := PHWndArray(lData);
  pWA^[0]       := pWA^[0] + 1;
  pWA^[pWA^[0]] := hWindow;

  Result := True;
end;

//=============================================================================
//  EnumThreadWindows() ̃bp[
//  Xbh̃gbvxEBhE̗
//=============================================================================
function AEnumThreadWindows(var WA: THWndArray; OneOfHandles: HWND): Integer;
begin
  WA[0] := 0;
  EnumThreadWindows(Windows.GetWindowThreadProcessId(OneOfHandles,
                    nil),
                    @EnumThreadWndProc,
                    LPARAM(@WA));
  Result := WA[0];
end;

//-----------------------------------------------------------------------------
//  EnumChildWindows̃R[obN֐
//-----------------------------------------------------------------------------
function EnumChildWndProc(hWindow: HWND; lData: LPARAM): BOOL; stdcall;
var
  pWA : PHWndArray;
begin
  pWA           := PHWndArray(lData);
  pWA^[0]       := pWA^[0] + 1;
  pWA^[pWA^[0]] := hWindow;

  Result := True;
end;

//=============================================================================
//  EnumChildWindows() ̃bp[
//  qCCБC...S
//=============================================================================
function AEnumChildWindows(var WA: THWndArray; hParent: HWND): Integer;
begin
  WA[0] := 0;
  EnumChildWindows(hParent, @EnumChildWndProc, LPARAM(@WA));
  Result := WA[0];
end;

//=============================================================================
//  ŗ񋓂C̃NX̂̂̃nhԂ
//=============================================================================
function FindChildOfClass(hParent: HWND; ClassName: String): HWND;
var
  WA  : THWndArray;
  i   : Integer;
  Num : Integer;
begin
  Result := 0;
  Num := AEnumChildWindows(WA, hParent);
  if Num > 0 then begin
    for i := 1 to Num do begin
      if UpperCase(GetClassNameStr(WA[i])) = UpperCase(ClassName) then begin
        Result := WA[i];
        break;
      end;
    end;
  end;
end;

//=============================================================================
//  ڂ̎qEBhÊݗ񋓂
//=============================================================================
function EnumDirectChildren(var WA: THWndArray; hParent: HWND): Integer;
var
  hWindow : HWND;
begin
  WA[0] := 0;
  hWindow := Windows.GetWindow(hParent, GW_CHILD);
  while (hWindow <> 0) do begin
    WA[0]     := WA[0] + 1;
    WA[WA[0]] := hWindow;
    hWindow   := Windows.GetWindow(hWindow, GW_HWNDNEXT);
  end;
  Result := WA[0];
end;

//=============================================================================
//  Cӂ̃EBhEŏʂ̃gbvxEBhE擾
//=============================================================================
function GetMostTopLevelWindow(hWindow: HWND): HWND;
var
  hAncestor : HWND;
  hPrev     : HWND;
begin
  hPrev := hWindow;
  hAncestor := Windows.GetParent(hPrev);
  while hAncestor <> 0  do begin
    hPrev     := hAncestor;
    hAncestor := Windows.GetParent(hPrev);
  end;

  hAncestor := hPrev;
  while hAncestor <> 0  do begin
    hPrev     := hAncestor;
    hAncestor := Windows.GetWindow(hPrev, GW_OWNER);
  end;
  Result := hPrev;
end;

//=============================================================================
//  ڂOwnedEBhE񋓂
//=============================================================================
function EnumDirectOwnedWindows(var WA: THWndArray; hOwner: HWND): Integer;
var
  WWA : THWndArray;
  i   : Integer;
  Num : Integer;
begin
  Result := 0;
  Num := AEnumThreadWindows(WWA, hOwner);
  if Num > 0 then begin
    for i := 1 to Num do begin
      if Windows.GetWindow(WWA[i], GW_OWNER) = hOwner then begin
        Inc(Result);
        WA[Result] := WWA[i];
      end;
    end;
  end;
end;

end.


